//AucunStyle_502f.js
// 16.05.15 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Annuler le lien au styles

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

if (app.documents.length == 0) {
	alert ("Il faut ouvrir un document InDesign.", "Attention");
	exit();
}

// une rfrence au document au premier plan
curDoc = app.documents[0];

// mmoriser le verrouillage des calques et l'annuler (si ncessaire)
var allLayers = curDoc.layers;
var nLayers = allLayers.length;
var layerLocks = new Array ();
for (var i=0; i<nLayers; i++) {
	if (allLayers[i].locked == true) {
		allLayers[i].locked = false;
		layerLocks.push(true);
	}
	else {
		layerLocks.push(false);
	}
}

// dverrouiller les blocs
curDoc.pageItems.everyItem().locked = false;

// les styles de paragraphe et de caractres "[Aucun]"
try {
	var noParaStyle = curDoc.paragraphStyles[0];
	var noCharStyle = curDoc.characterStyles[0];
}
catch (e) {
}

// les styles de paragraphe
var allParaStyles = curDoc.allParagraphStyles;
var nParaStyles = allParaStyles.length;

// restaurer les dfinitions GREP
app.findGrepPreferences = app.changeGrepPreferences = null;
// inclure les pages gabarit
app.findChangeGrepOptions.includeMasterPages = true;

// tester la slection
var curSel = app.selection;
var nSel   = curSel.length;

// l'objet cible
if (nSel == 0) {
	var curObj = curDoc;
	// lister et compter les chanes de texte
	allStories = curObj.stories;
	nStories   = allStories.length;
	convNums(curObj);
	setStyles(curObj);
	remStyles(curObj);
}
else {
	for (var i=0; i<nSel; i++) {
		if (curSel[i].constructor.name != "Group") {
			try {
				curObj = curSel[i].paragraphs.everyItem();
				convNums(curObj);
				setStyles(curObj);
				remStyles(curObj);
			}
			catch (e) {
			}
		}
		else {
			var allObj = curSel[i].allPageItems;
			var nObj   = allObj.length;
			for (var k=0; k<nObj; k++) {
				try {
					curObj = allObj[k].paragraphs.everyItem();
					convNums(curObj);
					setStyles(curObj);
					remStyles(curObj);
				}
				catch (e) {
				}
			}
		}
	}
}

// convertir les numrotations et les numrations en texte
function convNums(curObj) {
	if (curObj == curDoc) {
		for (var s=0; s<nStories; s++) {
			try {
				allStories[s].paragraphs.everyItem().convertBulletsAndNumberingToText();
			}
			catch (e) {
			}
			// traiter galement les tableaux
			try {
				allStories[s].tables.everyItem().cells.everyItem().texts[0].convertBulletsAndNumberingToText();
			}
			catch (e) {
			}
		}
	}
	else {
		try {
			curObj.convertBulletsAndNumberingToText();
		}
		catch (e) {
		}
		// traiter galement les tableaux
		try {
			curObj.tables.everyItem().cells.everyItem().texts[0].convertBulletsAndNumberingToText();
		}
		catch (e) {
		}
	}
}

// appliquer les styles de caractres aux styles GREP
function setStyles(curObj) {
	// une boucle  travers les styles de paragraphe
	for (p=0; p<nParaStyles; p++) {
		var allGrepStyles = allParaStyles[p].nestedGrepStyles;
		var nGrepStyles   = allGrepStyles.length;
		for (n=0; n<nGrepStyles; n++) {
			var curGrep = allGrepStyles[n].grepExpression;
			var curParaStyle  = allParaStyles[p];
			var curCharStyle  = allGrepStyles[n].appliedCharacterStyle;
			var curGrepChange = NothingEnum.nothing;
			app.findGrepPreferences.appliedParagraphStyle = curParaStyle;
			app.findGrepPreferences.appliedCharacterStyle = null;
			app.changeGrepPreferences.appliedCharacterStyle = curCharStyle;
			app.findGrepPreferences.findWhat = curGrep;
			app.changeGrepPreferences.changeTo = "";
			try {
				curObj.changeGrep();
			}
			catch (e) {
			}
		}
	}
}

// appliquer les deux styles "[Aucun]"
function remStyles(curObj) {
	if (curObj == curDoc) {
		// une boucle  travers chaque chane de texte
		for (var s=0; s<nStories; s++) {
			try {
				allStories[s].paragraphs.everyItem().applyCharacterStyle(noCharStyle);
			}
			catch (e) {
			}
			try {
				allStories[s].paragraphs.everyItem().applyParagraphStyle(noParaStyle, false);
			}
			catch (e) {
			}
			// traiter galement les tableaux
			try {
				allStories[s].tables.everyItem().cells.everyItem().texts[0].applyCharacterStyle(noCharStyle);
			}
			catch (e) {
			}
			try {
				allStories[s].tables.everyItem().cells.everyItem().texts[0].applyParagraphStyle(noParaStyle, false);
			}
			catch (e) {
			}
		}
	}
	else {
		try {
			curObj.paragraphs.everyItem().applyCharacterStyle(noCharStyle);
		}
		catch (e) {
		}
		try {
			curObj.paragraphs.everyItem().applyParagraphStyle(noParaStyle, false);
		}
		catch (e) {
		}
		// traiter galement les tableaux
		try {
			curObj.tables.everyItem().cells.everyItem().texts[0].applyCharacterStyle(noCharStyle);
		}
		catch (e) {
		}
		try {
			curObj.tables.everyItem().cells.everyItem().texts[0].applyParagraphStyle(noParaStyle, false);
		}
		catch (e) {
		}
	}
}

// restaurer les dfinitions GREP
app.findGrepPreferences = app.changeGrepPreferences = null;

// restaurer le verrouillage des calques (si ncessaire)
for (var i=0; i<(nLayers); i++) {
	allLayers[i].locked = layerLocks[i];
}

// informer l'utilisateur
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Termin.");
dlog.show();
$.sleep(999);
dlog.close();